Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToPdbActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToPdbActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToPdbActionBuilderModuleFactory.java	(revision 39157)
@@ -38,17 +38,18 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 * @param pdbUrlRoot
 		 */
 		public DocumentToPdbActionBuilderModule(
-				String predefinedTrust, String pdbUrlRoot) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold, String pdbUrlRoot) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 			this.pdbUrlRoot = pdbUrlRoot;
 		}
 	
 		@Override
 		public List<AtomicAction> build(DocumentToConceptIds object,
-				Agent agent, String actionSetId) {
+				Agent agent, String actionSetId) throws TrustLevelThresholdExceededException {
 			Oaf oaf = buildOAFWithPdb(object);
 			if (oaf!=null) {
 				return actionFactory.createUpdateActions(
@@ -64,8 +65,9 @@
 		 * Builds OAF object containing pdb external references.
 		 * @param source
 		 * @return OAF object containing pdb external references
+		 * @throws TrustLevelThresholdExceededException 
 		 */
-		protected Oaf buildOAFWithPdb(DocumentToConceptIds source) {
+		protected Oaf buildOAFWithPdb(DocumentToConceptIds source) throws TrustLevelThresholdExceededException {
 			if (source.getConcepts()!=null && 
 					source.getConcepts().size()>0) {
 				Result.Builder resultBuilder = Result.newBuilder();
@@ -106,17 +108,17 @@
 //			fallback
 			return null;
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentToConceptIds> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentToPdbActionBuilderModule(
-				predefinedTrust, config.get(EXPORT_PDB_URL_ROOT));
+				predefinedTrust, trustLevelThreshold, config.get(EXPORT_PDB_URL_ROOT));
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentAffiliationsActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentAffiliationsActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentAffiliationsActionBuilderModuleFactory.java	(revision 39157)
@@ -55,12 +55,13 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 * @param countriesVocabulary
-		 * @param actionSetId
 		 */
 		public DocumentMetadataActionBuilderModule(String predefinedTrust,
+				Float trustLevelThreshold,
 				Properties countriesVocabulary) {
-			super(predefinedTrust, algorithmName);
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 			this.countriesVocabulary = countriesVocabulary;
 			try {
 				entityTargetColumn = new String(
@@ -234,16 +235,11 @@
 					orgEntityBuilder.build(), buildInference());
 			return organizationOaf;
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentMetadata> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		String countriesVocabularyLocation = config.get(COUNTRIES_VOCABULARY_LOCATION);
 		Properties countriesVocabularyProps = null;
 		if (countriesVocabularyLocation!=null) {
@@ -256,7 +252,12 @@
 			}
 		} 
 		return new DocumentMetadataActionBuilderModule(
-				predefinedTrust, countriesVocabularyProps);	
+				predefinedTrust, trustLevelThreshold, countriesVocabularyProps);	
 		
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/MappingNotDefinedException.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/MappingNotDefinedException.java	(nonexistent)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/MappingNotDefinedException.java	(revision 39157)
@@ -0,0 +1,24 @@
+package eu.dnetlib.iis.export.actionmanager.module;
+
+/**
+ * Exception raised when no actionset mapping was defined for given algorithm.
+ * @author mhorst
+ *
+ */
+public class MappingNotDefinedException extends RuntimeException {
+
+	/**
+	 * 
+	 */
+	private static final long serialVersionUID = 8868977210154868434L;
+
+	
+	public MappingNotDefinedException() {
+		super();
+	}
+
+	public MappingNotDefinedException(String message) {
+		super(message);
+	}
+
+}

Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToProjectActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToProjectActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToProjectActionBuilderModuleFactory.java	(revision 39157)
@@ -38,15 +38,16 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
-		 * @param actionSetId
+		 * @param trustLevelThreshold
 		 */
-		public DocumentToProjectActionBuilderModule(String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+		public DocumentToProjectActionBuilderModule(
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
 		public List<AtomicAction> build(DocumentToProject object, 
-				Agent agent, String actionSetId) {
+				Agent agent, String actionSetId) throws TrustLevelThresholdExceededException {
 			String docId = object.getDocumentId().toString();
 			String currentProjectIdStr = object.getProjectId().toString();
 			Oaf.Builder oafBuilder = Oaf.newBuilder();
@@ -126,17 +127,17 @@
 						"no relation object found!");
 			}
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentToProject> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentToProjectActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ActionBuilderFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ActionBuilderFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ActionBuilderFactory.java	(revision 39157)
@@ -13,10 +13,16 @@
 	/**
 	 * Instantiates action builder module.
 	 * @param predefinedTrust
+	 * @param trustLevelThreshold
 	 * @param config hadoop configuration holding runtime parameters
 	 * @return
 	 */
-	ActionBuilderModule<T> instantiate(String predefinedTrust, Configuration config);
-
+	ActionBuilderModule<T> instantiate(String predefinedTrust, Float trustLevelThreshold, 
+			Configuration config);
+	/**
+	 * Provides algorithm name.
+	 * @return algorithm name
+	 */
+	AlgorithmName getAlgorithName();
 	
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ProjectToProjectStatisticsActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ProjectToProjectStatisticsActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ProjectToProjectStatisticsActionBuilderModuleFactory.java	(revision 39157)
@@ -35,10 +35,11 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 */
 		public ProjectToProjectStatisticsActionBuilderModule(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 		
 		@Override
@@ -78,19 +79,20 @@
 	//		fallback
 			return null;	
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
+
 	}
 
 
 	@Override
 	public ActionBuilderModule<ProjectToProjectStatistics> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new ProjectToProjectStatisticsActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/PersonsWithWebsiteUsageSimilaritiesActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/PersonsWithWebsiteUsageSimilaritiesActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/PersonsWithWebsiteUsageSimilaritiesActionBuilderModuleFactory.java	(revision 39157)
@@ -38,10 +38,11 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 */
 		public PersonsWithWebsiteUsageSimilaritiesActionBuilderModule(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -115,18 +116,18 @@
 			oafBuilder.setTimestamp(System.currentTimeMillis());
 			return oafBuilder.build();
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 	
 	@Override
 	public ActionBuilderModule<PersonsWithWebsiteUsageSimilarities> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new PersonsWithWebsiteUsageSimilaritiesActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AbstractBuilderModule.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AbstractBuilderModule.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AbstractBuilderModule.java	(revision 39157)
@@ -25,6 +25,11 @@
 	private final String predefinedTrust;
 	
 	/**
+	 * Trust level threshold, null when not specified.
+	 */
+	private final Float trustLevelThreshold;
+	
+	/**
 	 * Confidence to trust level normalization factor.
 	 */
 	private float confidenceToTrustLevelNormalizationFactor = HBaseConstants.CONFIDENCE_TO_TRUST_LEVEL_FACTOR;
@@ -47,11 +52,14 @@
 	/**
 	 * Default constructor.
 	 * @param predefinedTrust
+	 * @param trustLevelThreshold
 	 * @param inferenceProvenance
 	 */
 	public AbstractBuilderModule(String predefinedTrust,
+			Float trustLevelThreshold,
 			AlgorithmName algorithmName) {
 		this.predefinedTrust = predefinedTrust;
+		this.trustLevelThreshold = trustLevelThreshold;
 		this.inferenceProvenance = buildInferenceProvenance(algorithmName);
 	}
 	
@@ -97,7 +105,7 @@
 	 * @return inference object
 	 */
 	protected DataInfo buildInference() {
-		return buildInference(predefinedTrust);
+		return buildInferenceForTrustLevel(predefinedTrust);
 	}
 	
 	/**
@@ -104,11 +112,16 @@
 	 * Returns inference object.
 	 * Confidence level will be normalized to trust level.
 	 * @param confidenceLevel confidence level which will be normalized to trust level
+	 * @throws TrustLevelThresholdExceededException thrown when trust level threshold was exceeded
 	 * @return inference object
 	 */
-	protected DataInfo buildInference(float confidenceLevel) {
-		return buildInference(this.decimalFormat.format(
-				confidenceLevel*this.confidenceToTrustLevelNormalizationFactor));
+	protected DataInfo buildInference(float confidenceLevel) throws TrustLevelThresholdExceededException {
+		float currentTrustLevel = confidenceLevel*this.confidenceToTrustLevelNormalizationFactor;
+		if (trustLevelThreshold==null || currentTrustLevel>=trustLevelThreshold) {
+			return buildInferenceForTrustLevel(this.decimalFormat.format(currentTrustLevel));
+		} else {
+			throw new TrustLevelThresholdExceededException();
+		}
 	}
 
 	/**
@@ -116,7 +129,7 @@
 	 * @param trustLevel
 	 * @return inference object
 	 */
-	private DataInfo buildInference(String trustLevel) {
+	private DataInfo buildInferenceForTrustLevel(String trustLevel) {
 		DataInfo.Builder builder = DataInfo.newBuilder();
 		builder.setInferred(true);
 		builder.setTrust(trustLevel);
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ExtractedDocumentMetadataActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ExtractedDocumentMetadataActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ExtractedDocumentMetadataActionBuilderModuleFactory.java	(revision 39157)
@@ -42,12 +42,12 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
-		 * @param actionSetId
+		 * @param trustLevelThreshold
 		 * @param skipOriginalMetadata flag indicating overwriting already existing data should be prevented
 		 */
 		public ExtractedDocumentMetadataActionBuilderModule(String predefinedTrust,
-				boolean skipOriginalMetadata) {
-			super(predefinedTrust, algorithmName);
+				Float trustLevelThreshold, boolean skipOriginalMetadata) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 			this.skipOriginalMetadata = skipOriginalMetadata;
 		}
 	
@@ -234,17 +234,17 @@
 					!source.getExternalIdentifiers().isEmpty();
 		}
 
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 	
 	@Override
 	public ActionBuilderModule<ExtractedDocumentMetadata> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new ExtractedDocumentMetadataActionBuilderModule(
-				predefinedTrust, true);
+				predefinedTrust, trustLevelThreshold, true);
 	}
 
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentsWithWebsiteUsageSimilaritiesActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentsWithWebsiteUsageSimilaritiesActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentsWithWebsiteUsageSimilaritiesActionBuilderModuleFactory.java	(revision 39157)
@@ -35,11 +35,11 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
-		 * @param actionSetId
+		 * @param trustLevelThreshold
 		 */
 		public DocumentsWithWebsiteUsageSimilaritiesActionBuilder(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -96,18 +96,18 @@
 			oafBuilder.setTimestamp(System.currentTimeMillis());
 			return oafBuilder.build();
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 
 	@Override
 	public ActionBuilderModule<DocumentsWithWebsiteUsageSimilarities> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentsWithWebsiteUsageSimilaritiesActionBuilder(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentSimilarityActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentSimilarityActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentSimilarityActionBuilderModuleFactory.java	(revision 39157)
@@ -1,5 +1,7 @@
 package eu.dnetlib.iis.export.actionmanager.module;
 
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_DOCUMENTSSIMILARITY_THRESHOLD;
+
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
@@ -37,7 +39,7 @@
 	class DocumentSimilarityActionBuilderModule extends AbstractBuilderModule 
 	implements ActionBuilderModule<DocumentSimilarity> {
 	
-		private final Float threshold;
+		private final Float similarityThreshold;
 		
 		/**
 		 * Default constructor.
@@ -45,10 +47,10 @@
 		 * @param threshold similarity threshold, skipped when null
 		 */
 		public DocumentSimilarityActionBuilderModule(
-				String predefinedTrust,
-				Float threshold) {
-			super(predefinedTrust, algorithmName);
-			this.threshold = threshold;
+				String predefinedTrust, Float trustLevelThreshold,
+				Float similarityThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
+			this.similarityThreshold = similarityThreshold;
 		}
 		
 		@Override
@@ -58,8 +60,8 @@
 				return Collections.emptyList();
 			}
 //			checking similarity threshold if set
-			if (threshold!=null && object.getSimilarity()!=null &&
-					object.getSimilarity()<threshold) {
+			if (similarityThreshold!=null && object.getSimilarity()!=null &&
+					object.getSimilarity()<similarityThreshold) {
 				return Collections.emptyList();
 			}
 //			setting relations in both source and target objects
@@ -152,25 +154,25 @@
 			oafBuilder.setTimestamp(System.currentTimeMillis());
 			return oafBuilder.build();
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentSimilarity> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		String thresholdStr = config.get(
-				WorkflowRuntimeParameters.EXPORT_DOCUMENTSSIMILARITY_THRESHOLD);
-		Float threshold = null;
+				EXPORT_DOCUMENTSSIMILARITY_THRESHOLD);
+		Float similarityThreshold = null;
 		if (thresholdStr!=null && !WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(
 				thresholdStr)) {
-			threshold = Float.valueOf(thresholdStr);
-			log.warn("setting documents similarity exporter threshold to: " + threshold);
+			similarityThreshold = Float.valueOf(thresholdStr);
+			log.warn("setting documents similarity exporter threshold to: " + similarityThreshold);
 		}
 		return new DocumentSimilarityActionBuilderModule(
-				predefinedTrust, threshold);
+				predefinedTrust, trustLevelThreshold, similarityThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDataSetActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDataSetActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDataSetActionBuilderModuleFactory.java	(revision 39157)
@@ -36,14 +36,16 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 */
-		public DocumentToDataSetActionBuilderModule(String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+		public DocumentToDataSetActionBuilderModule(
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
 		public List<AtomicAction> build(DocumentToDataSet object, Agent agent,
-				String actionSetId) {
+				String actionSetId) throws TrustLevelThresholdExceededException {
 			String docId = object.getDocumentId().toString();
 			String currentRefId = object.getDatasetId().toString();
 			Oaf.Builder oafBuilder = Oaf.newBuilder();
@@ -85,17 +87,17 @@
 						oafInverted.toByteArray())
 			});
 		}
-
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentToDataSet> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentToDataSetActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ActionBuilderModule.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ActionBuilderModule.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/ActionBuilderModule.java	(revision 39157)
@@ -19,15 +19,10 @@
 	 * @param agent action agent
 	 * @param actionSetId action set identifier
 	 * This instance should be used in read-only mode.
+	 * @throws TrustLevelThresholdExceededException thrown when trust level threshold was exceeded
 	 * @return collection of actions
 	 */
-	List<AtomicAction> build(T object, Agent agent, String actionSetId);
-
-	/**
-	 * Provides algorithm name.
-	 * @return algorithm name
-	 */
-	AlgorithmName getAlgorithName();
+	List<AtomicAction> build(T object, Agent agent, String actionSetId) throws TrustLevelThresholdExceededException;
 	
 }
 
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AlgorithmMapper.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AlgorithmMapper.java	(nonexistent)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AlgorithmMapper.java	(revision 39157)
@@ -0,0 +1,17 @@
+package eu.dnetlib.iis.export.actionmanager.module;
+
+
+/**
+ * Algorithm mapper.
+ * @author mhorst
+ *
+ */
+public interface AlgorithmMapper<V> {
+
+	/**
+	 * @param algorithmName
+	 * @return
+	 * @throws MappingNotDefinedException when no value defined for given algorithm.
+	 */
+	V getValue(AlgorithmName algorithmName) throws MappingNotDefinedException; 
+}

Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/TrustLevelThresholdExceededException.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/TrustLevelThresholdExceededException.java	(nonexistent)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/TrustLevelThresholdExceededException.java	(revision 39157)
@@ -0,0 +1,15 @@
+package eu.dnetlib.iis.export.actionmanager.module;
+
+/**
+ * Exception indicating trust level threshold was exceeded.
+ * @author mhorst
+ *
+ */
+public class TrustLevelThresholdExceededException extends Exception {
+
+	/**
+	 * 
+	 */
+	private static final long serialVersionUID = -2970837120188552368L;
+
+}

Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/TableCreatorProcess.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/TableCreatorProcess.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/TableCreatorProcess.java	(revision 39157)
@@ -1,5 +1,8 @@
 package eu.dnetlib.iis.export.actionmanager;
 
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_TABLE_INITIALIZE;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_TABLE_NAME;
+
 import java.io.IOException;
 import java.util.Collections;
 import java.util.Map;
@@ -16,7 +19,6 @@
 
 import eu.dnetlib.actionmanager.ActionManagerConstants;
 import eu.dnetlib.actionmanager.ActionManagerConstants.COLUMN_FAMILIES;
-import eu.dnetlib.iis.common.WorkflowRuntimeParameters;
 import eu.dnetlib.iis.core.java.PortBindings;
 import eu.dnetlib.iis.core.java.Process;
 import eu.dnetlib.iis.core.java.ProcessUtils;
@@ -46,12 +48,12 @@
 	public void run(PortBindings portBindings, Configuration conf,
 			Map<String, String> parameters) throws Exception {
 		String initializeTable = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_TABLE_INITIALIZE, 
+				EXPORT_ACTION_HBASE_TABLE_INITIALIZE, 
 				conf, parameters);
 		if (initializeTable!=null && !initializeTable.isEmpty() && 
 				Boolean.parseBoolean(initializeTable)) {
 			String hBaseTableName = ProcessUtils.getParameterValue(
-					WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_TABLE_NAME, 
+					EXPORT_ACTION_HBASE_TABLE_NAME, 
 					conf, parameters);
 			if (hBaseTableName!=null) {
 				prepareTable(false, hBaseTableName, 
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/actionset/ActionSetManagementProcess.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/actionset/ActionSetManagementProcess.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/actionset/ActionSetManagementProcess.java	(revision 39157)
@@ -1,5 +1,7 @@
 package eu.dnetlib.iis.export.actionmanager.actionset;
 
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_SETID;
+
 import java.util.Collections;
 import java.util.List;
 import java.util.Map;
@@ -30,7 +32,7 @@
 
 	public static final String PARAM_ACTION_MANAGER_SERVICE_LOCATION = "export.actionmanager.service.location";
 	
-	public static final String PARAM_ACTION_SET_ID = WorkflowRuntimeParameters.EXPORT_ACTION_SETID;
+	public static final String PARAM_ACTION_SET_ID = EXPORT_ACTION_SETID;
 
 	
 	@Override
